/*
Code mainly borrowed from
http://www.windmeadow.com/node/42

Special Thanks to Chad
*/

void nunchuckIni()
{
  Wire.begin();	                // join i2c bus as master
  Wire.beginTransmission(0x52);	// transmit to device 0x52
  Wire.send(0x40);		// sends memory address
  Wire.send(0x00);		// sends sent a zero.  
  Wire.endTransmission();	// stop transmitting
}

void nunchuckSendRequest()
{
  Wire.beginTransmission(0x52);	// transmit to device 0x52
  Wire.send(0x00);
  Wire.endTransmission();	// stop transmitting
}

void nunchuckRead()
{
  byte temp;
  double timeOut;
  Wire.requestFrom (0x52, 6);	// request data from nunchuck
  for(byte i = 0; i < 6; i++)
  {
    timeOut = 0;
    while((Wire.available() == 0) && (timeOut < 200000)) // waits for byte, or timeout after .2 million tries
    {
      timeOut++;
    }
    // receive byte
    nunchuckBuffer[i] = nunchuckDecode(Wire.receive());
  }
  nunchuckSendRequest();  // send request for next data payload
}

byte nunchuckDecode(byte x_)
{
  x_ = (x_ ^ 0x17) + 0x17; // ^ means XOR
  // Nintendo encoded their data, but this decodes it
  return x_;
}
